Attribute VB_Name = "Module1"
Option Explicit
'Copyright (C) 2002 by Benjamin Wilger
'Kontakt: Benjamin Wilger

'Gibt einen Hex-String mit fhrenden Nullen zurck.
Private Function toHex(ByVal Number As Long, _
                       ByVal NumLen As Integer, _
                        Optional ByVal UpperCase As Boolean) As String
    
    Dim C As String
    
    C = Hex(Number)

    If Len(C) < NumLen Then
        C = String(NumLen - Len(C), "0") & C
    End If
 
    If Not UpperCase Then
        toHex = LCase(C)
    Else
        toHex = C
    End If
 
End Function

' String URLEncoden
Public Function URLEncode(ByVal strInput As String) As String
    Dim strResult, lngChar As Long
    
    Do While Len(strInput) > 0
        lngChar = Asc(strInput)
        strInput = Right(strInput, Len(strInput) - 1)
        If (lngChar >= Asc("a") And lngChar <= Asc("z")) Or _
            (lngChar >= Asc("A") And lngChar <= Asc("Z")) Or _
            (lngChar >= Asc("0") And lngChar <= Asc("9")) Then
            strResult = strResult & Chr(lngChar)
        ElseIf lngChar = Asc(" ") Then
            strResult = strResult & "+"
        Else
            strResult = strResult & "%" & toHex(lngChar, 2)
        End If
    Loop
    
    URLEncode = strResult
End Function

' String URLDecoden
Public Function URLDecode(ByVal strInput As String) As String
    Dim strResult, lngChar As Long, strChar As String
    Dim i As Long
    
    For i = 1 To Len(strInput)
        strChar = Mid$(strInput, i, 1)
        If strChar = "+" Then
            strResult = strResult & " "
        ElseIf strChar = "%" Then
            strResult = strResult & _
            Chr(Val("&H" & Mid$(strInput, i + 1, 1) & _
            Mid$(strInput, i + 2, 1)))
            i = i + 2 'Zwei Zeichen berspringen
        Else
            strResult = strResult & strChar
        End If
    Next i
    
    URLDecode = strResult
End Function
